#pragma GCC optimize("O3")
#pragma GCC target("avx2")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <cstdint>
#include <stack>
#include <array>
using namespace std;
using i64 = int64_t;

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	i64 n, m;
	cin >> n >> m;

	vector<string> map(n, "123456");
	vector<pair<int, int>> free;

	for (int i = 0; i < n; ++i) {
		char c;

		for (int j = 0; j < 6; j++)
		{
			cin >> c;
			map[i][j] = c;
		}
	}

	stack<pair<int, int>> p;

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < 3; j++)
		{
			if (map[i][j] != map[i][5-j]) {
				if (map[i][j] == 'X') {
					map[i][5-j] = 'X';
					m--;
				}
				else {
					map[i][j] = 'X';
					m--;
				}
			}
			else {
				if (map[i][j] == '.') {
					p.push({ i,j });
				}
			}
		}
	}

	if (m < 0) {
		cout << "Impossible" << endl;
		return 0;
	}

	while (m > 0 && !p.empty()) {
		auto[y, x] = p.top();
		p.pop();

		map[y][x] = map[y][5-x] = 'X';

		m -= 2;
	}

	if (m == 0) {
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < 6; j++)
			{
				cout << map[i][j];
			}
			cout << '\n';
		}
		cout << endl;
	}
	else {
		cout << "Impossible" << endl;
		return 0;
	}

	return 0;
}

/*
6 7
X.....
......
....X.
X.....
......
..XX..
*/