#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <numbers>
#include <numeric>
#include <cstdint>
#include <array>
using namespace std;
using i64 = int64_t;

enum Mode{
    More, Less, Eq
};
struct Seg{
    int start=-1, end=-1, center=-1;
};

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    i64 n;
    cin >> n;

    vector<i64> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<Mode> md(n-1);
    vector<Seg> segs;

    for (int i = 0; i < n-1; ++i) {
        if(a[i] < a[i+1])
            md[i] = Less;
        else if (a[i] > a[i+1])
            md[i] = More;
        else
            md[i] = Eq;
    }

    for (int i = 0; i < n-1;) {
        Seg s;

        while (i<n-1&&md[i]!=Less)
            i++;
        s.start=i;
        while (i<n-1&&md[i]==Less)
            i++;
        s.center = i;
        while (i<n-1&&md[i] == More)
            i++;
        s.end  =  i;

        segs.push_back(s);
    }

    i64 sum = n;

    for (int i = 0; i < segs.size(); ++i) {
        auto&seg = segs[i];

        i64 S = seg.end - seg.start + 1;
        i64 l;

        if(S%2==0){
            l=S/2*(S-1);
        }else{
            l=(S-1)/2*S;
        }

        sum += l;
    }

    cout << sum;
    return 0;
}