#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <cstdint>
#include <array>
#include <queue>
#include <stack>
using namespace std;
using i64 = int64_t;
using mp_t = vector<vector<i64>>;

vector<i64> xs;
vector<i64> ys;

vector<int> dropped_h{ -1 };// x
vector<int> dropped_v{ -1 };// y
i64 h, w;
i64 target;

void SIGNAL() {
    cout << "YES\n";
    for (size_t i = 1; i < dropped_v.size(); i++)
        cout << "2 " << dropped_v[i]+1 << endl;
    for (size_t i = 1; i < dropped_h.size(); i++)
        cout << "1 " << dropped_h[i] +1<< endl;

    exit(0);
}

void trh(const mp_t& m, i64 sum) {
    if (sum == target)
        SIGNAL();
    for (int i = dropped_h.back() + 1; i < h; ++i) { // hor
        i64 s = sum - xs[i];

        dropped_h.push_back(i);

        for (int j = 1; j < dropped_v.size(); ++j) {
            for (int k = 1; k < dropped_h.size(); ++k) {
                s += m[dropped_h[k]][dropped_v[j]];
            }
        }

        trh(m, s);
        dropped_h.pop_back();

        if (s < target)
            continue;
    }
}
void tr(const mp_t& m, i64 sum) {
    if (sum == target)
        SIGNAL();

    trh(m, sum);

    for (int i = dropped_v.back() + 1; i < w; ++i) { // vert
        i64 s = sum - ys[i];
        dropped_v.push_back(i);
        tr(m, s);
        dropped_v.pop_back();

        if (s < target)
            continue;
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> h >> w;

    mp_t map(h, vector<i64>(w));

    xs.resize(h, 0);
    ys.resize(w, 0);
    //vector<pair<int, i64>> ys(w, {0,0});

    //vector<pair<int, i64>> xs(h, {0,0});

    i64 sum = 0;

    for (int i = 0; i < h; ++i) {
        //ys[i].second = i;
        //xs[i].second = i;
        for (int j = 0; j < w; ++j) {
            cin >> map[i][j];
            //ys[j].first+=map[i][j];
            ys[j] += map[i][j];
            //xs[i].first+=map[i][j];
            xs[i] += map[i][j];

            sum += map[i][j];
        }
    }
    cin >> target;

    // sort(ys.rbegin(), ys.rend());

    tr(map, sum);

    cout << "NO" << endl;

    return 0;
}